// -----------------------------------------------------------------------
// <copyright file="QueryProvisionResponseBuilder.cs" company="EUROSTAT">
//   Date Created : 2013-01-29
//   Copyright (c) 2012, 2016 by the European Union. 
//     All rights reserved. This program and the accompanying materials are made
//    available under the terms of the GNU Lesser General Public License v 3.0
//    which accompanies this distribution, and is available at
//    http://www.gnu.org/licenses/lgpl.html
//     This file is part of SdmxStructureParser.
//     SdmxStructureParser is free software: you can redistribute it and/or modify
//     it under the terms of the GNU Lesser General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
//     SdmxStructureParser is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU Lesser General Public License for more details.
//     You should have received a copy of the GNU Lesser General Public License
//     along with SdmxStructureParser.  If not, see <http://www.gnu.org/licenses/>.
//     Contributors:
//     Metadata Technology - initial API and implementation
// </copyright>
// -----------------------------------------------------------------------
namespace Org.Sdmxsource.Sdmx.Structureparser.Builder.XmlSerialization.Registry.Response
{
    using System;
    using System.Collections.Generic;

    using Org.Sdmxsource.Sdmx.Api.Constants;
    using Org.Sdmxsource.Sdmx.Api.Exception;
    using Org.Sdmxsource.Sdmx.Api.Model.Objects;
    using Org.Sdmxsource.Sdmx.Api.Model.Objects.Registry;
    using Org.Sdmxsource.Sdmx.Structureparser.Builder.XmlSerialization.Registry.Response.V2;
    using Org.Sdmxsource.Sdmx.Structureparser.Builder.XmlSerialization.Registry.Response.V21;
    using Org.Sdmxsource.Sdmx.Util.Objects.Container;

    using Xml.Schema.Linq;

    /// <summary>
    ///     Builds error and success responses for querying provisions.
    /// </summary>
    public class QueryProvisionResponseBuilder : XmlObjectBuilder, IQueryProvisionResponseBuilder
    {
        /// <summary>
        ///     The error response builder 21.
        /// </summary>
        private readonly ErrorResponseBuilder _errorResponseBuilder21;

        /// <summary>
        ///     The v 2 builder.
        /// </summary>
        private readonly QueryProvisionResponseBuilderV2 _queryProvisionResponseBuilderV2;

        /// <summary>
        ///     The query structure response builder.
        /// </summary>
        private readonly IQueryStructureResponseBuilder _queryStructureResponseBuilder;

        /// <summary>
        /// Initializes a new instance of the <see cref="QueryProvisionResponseBuilder"/> class.
        /// </summary>
        /// <param name="errorResponseBuilder21">The error response builder21.</param>
        /// <param name="queryProvisionResponseBuilderV2">The query provision response builder v2.</param>
        /// <param name="queryStructureResponseBuilder">The query structure response builder.</param>
        public QueryProvisionResponseBuilder(ErrorResponseBuilder errorResponseBuilder21, QueryProvisionResponseBuilderV2 queryProvisionResponseBuilderV2, IQueryStructureResponseBuilder queryStructureResponseBuilder)
        {
            this._errorResponseBuilder21 = errorResponseBuilder21;
            this._queryProvisionResponseBuilderV2 = queryProvisionResponseBuilderV2;
            this._queryStructureResponseBuilder = queryStructureResponseBuilder;
        }

        /// <summary>
        ///     Initializes a new instance of the <see cref="QueryProvisionResponseBuilder" /> class.
        /// </summary>
        public QueryProvisionResponseBuilder()
        {
            this._queryProvisionResponseBuilderV2 = QueryProvisionResponseBuilderV2.Instance;
            this._errorResponseBuilder21 = new ErrorResponseBuilder();
            this._queryStructureResponseBuilder = new QueryStructureResponseBuilder();
        }

        /// <summary>
        ///     Gets a QueryProvisioningResponse with a failure status along with an
        ///     error message generated from the <paramref name="exception" />
        /// </summary>
        /// <param name="exception">
        ///     The exception generated by the failure
        /// </param>
        /// <param name="schemaVersion">
        ///     The schema Version.
        /// </param>
        /// <returns>
        ///     The <see cref="XTypedElement" />.
        /// </returns>
        public virtual XTypedElement BuildErrorResponse(Exception exception, SdmxSchemaEnumType schemaVersion)
        {
            XTypedElement response = null;
            switch (schemaVersion)
            {
                case SdmxSchemaEnumType.VersionTwo:
                    response = this._queryProvisionResponseBuilderV2.BuildErrorResponse(exception);
                    break;
                case SdmxSchemaEnumType.VersionTwoPointOne:
                    response = this._errorResponseBuilder21.BuildErrorResponse(exception);
                    break;
                default:
                    throw new SdmxNotImplementedException(ExceptionCode.Unsupported, schemaVersion);
            }

            this.WriteSchemaLocation(response, schemaVersion);
            return response;
        }

        /// <summary>
        ///     Builds a QueryProvisioningResponse with a success status, along with
        ///     the provisions returned from the query, if there are no provisions returned
        ///     this will be noted in the response message.
        /// </summary>
        /// <param name="provisions">
        ///     The source provisions
        /// </param>
        /// <param name="schemaVersion">
        ///     The schema Version.
        /// </param>
        /// <returns>
        ///     The <see cref="XTypedElement" />.
        /// </returns>
        public virtual XTypedElement BuildSuccessResponse(
            ICollection<IProvisionAgreementObject> provisions, 
            SdmxSchemaEnumType schemaVersion)
        {
            XTypedElement response = null;
            switch (schemaVersion)
            {
                case SdmxSchemaEnumType.VersionTwo:
                    response = this._queryProvisionResponseBuilderV2.BuildSuccessResponse(provisions);
                    break;
                case SdmxSchemaEnumType.VersionTwoPointOne:
                    ISdmxObjects beans = new SdmxObjectsImpl();
                    beans.AddIdentifiables(provisions);
                    response = this._queryStructureResponseBuilder.BuildSuccessResponse(beans, schemaVersion, false);
                    break;
                default:
                    throw new SdmxNotImplementedException(ExceptionCode.Unsupported, schemaVersion);
            }

            this.WriteSchemaLocation(response, schemaVersion);
            return response;
        }
    }
}